/* 
 Copyright 2005-2007 Foxmarks Inc.

 foxmarks-overlay.js: implement the foxmarks overlay into the main browser
 window
 */

var foxmarksObserver = {
    observe: function(subject, topic, data) {
        var result = eval(data);
        status = result.status;
        msg = result.msg || "";
        complete = status != 1;

        window.XULBrowserWindow.setJSStatus("Foxmarks: " + msg);

        if (complete) {
            setTimeout(foxmarksObserver.clearStatus, status != 0 ? 5000: 1000);
        }
    },

    clearStatus: function() {
        window.XULBrowserWindow.setJSStatus("");
     }
}

function FoxmarksBrowserLoad() {
    var os = Cc["@mozilla.org/observer-service;1"].
        getService(Ci.nsIObserverService);
    os.addObserver(foxmarksObserver, "foxmarks-service", false);

    return;
}

function FoxmarksOnPopupShowing() {
    if (gSettings.hideStatusIcon) {
        document.getElementById("foxmarks-showstatusicon").
            removeAttribute("checked");
    } else {
        document.getElementById("foxmarks-showstatusicon").
            setAttribute("checked", "true");
    }
    return true;
}

function FoxmarksToggleIcon(event) {
    gSettings.hideStatusIcon = !gSettings.hideStatusIcon;
}

function FoxmarksBrowserUnload() {
    var os = Cc["@mozilla.org/observer-service;1"].
        getService(Ci.nsIObserverService);

    try {
        os.removeObserver(foxmarksObserver, "foxmarks-service");
    } catch (e) {
        LogWrite("Warning: removeObserver failed.");
    }
}

window.addEventListener("load", FoxmarksBrowserLoad, false);
window.addEventListener("unload", FoxmarksBrowserUnload, false);

