/* 
 Copyright 2005-2008 Foxmarks Inc.
 
 foxmarks-setup.js: implements behavior for the Foxmarks Setup Wizard.
   
 */


var gIsEmpty;
var gWizardSession = Date.now().toString(36);
var gHelpUrl;

function SetupOnLoad() {
    var retval = SetupValidateLogin();

    if (!retval.status) {
        document.documentElement.
            goTo(gIsEmpty ? "execute" : "selectSyncOption");
    } else {
        document.documentElement.goTo("errorPage");
        document.getElementById("errormsg").value = retval.msg;
        var errmsg = retval.msg.replace(/ /g, "_");
        gHelpUrl = Bundle().formatStringFromName("url.error", [errmsg], 1);
    }
    return false;
}


function SetupValidateLogin() {
    var retval = {};

    SetupPerformAction("status", retval);
    if (retval.status) {
        var sb = Bundle();

        if (retval.status == 401 || retval.status == 403) {
            alert(sb.GetStringFromName("msg.invalidlogin"));
            window.close();
            FoxmarksOpenWizard(window.arguments[0], false);
        }
        return retval;
    }

    gIsEmpty = retval.result.isreset == "true" || retval.result.isreset == true;
    return retval;
}

function FoxmarksSetupHelp() {
    if (gHelpUrl) {
        FoxmarksOpenInNewWindow(gHelpUrl);
    }
}

function SetupIsMerging() {
    return !gIsEmpty && 
        document.getElementById("localOrRemote").selectedItem.value == "merge";
}

// Skip over merge options if the user hasn't selected merge.
function SetupOptionNext() {
    document.documentElement.getPageById("selectSyncOption").next = 
        SetupIsMerging() ? "mergeOption" : "execute";
    return true;
}

function SetupShowExecutePage() {
    var op;
    var a = document.getElementById("localOrRemote").selectedItem.value;
    var b = document.getElementById("mergeStart").selectedItem.value;

    if (gIsEmpty) {
        op = "msg.upload";
    } else {
        if (a == "local") {
            op = "msg.upload";
        } else if (a == "remote") {
            op = "msg.download";
        } else {
            if (b == "local") {
                op = "msg.mergelocal";
            } else {
                op = "msg.mergeremote";
            }
        }
    }
    document.getElementById("operation").value = Bundle().GetStringFromName(op);
    if (!gIsEmpty && a != "merge") {
        document.getElementById("warning").value =
            Bundle().GetStringFromName(op + ".warning");
    } else {
        document.getElementById("warning").value = null;
    }
}

function SetupPerformSync() {
    var retval = {}
    var args = {};

    var a = document.getElementById("localOrRemote").selectedItem.value;
    var b = document.getElementById("mergeStart").selectedItem.value;

    args.merge = SetupIsMerging();
    args.remoteIsMaster = gIsEmpty ? false :
        (args.merge ? (b == "remote") : (a == "remote"));

    SetupPerformAction("initialSync", retval, args);

    if (!retval.status) {
        return true;
    } else {
        alert(Bundle().formatStringFromName("msg.syncfailed",
                [retval.msg], 1));
    }

    return false;
}

function SetupPerformAction(action, retval, args) {
    var win = window.
            openDialog("chrome://foxmarks/content/foxmarks-progress.xul",
            "_blank", "chrome,dialog,modal,centerscreen", action, retval, args);

    if (retval.helpurl) {
        openDialog("chrome://browser/content/browser.xul", "_blank",
            "chrome,all,dialog=no", retval.helpurl);
        retval.status = -1;
        retval.msg = Bundle().GetStringFromname("msg.cancelled");
    }

    return;
}

function SetupOnWizardFinish() {
    gSettings.majorVersion = 2;
    FoxmarksOpenInNewTab("http://login.foxmarks.com/success");
    return true;
}

function OnPageShow(pageId) {
    var attrs = [];
    attrs.push("app="       + "jezebel");
    attrs.push("mid="       + gSettings.machineId);
    attrs.push("sess="      + gWizardSession);
    attrs.push("page="      + pageId);
    attrs.push("username="  + gSettings.username);
    attrs.push("no_cache="  + Date.now().toString(36));
    attrs.push("manual="    + window.arguments[0]);

    var query = attrs.join("&");
    var img = document.getElementById(pageId + "Ping");
    img.src = "http://tr.foxmarks.com/tracking/impressions.gif?" + query;
}
