/* 
 Copyright 2008 Foxmarks Inc.

 foxmarks-uitools.js: Various and sundry UI functions. 

 */


function FoxmarksOpenWindowByType(inType, uri, features, args) {
    var wm = Cc['@mozilla.org/appshell/window-mediator;1'].
        getService(Ci.nsIWindowMediator);
    var topWindow = wm.getMostRecentWindow(inType);

    if (topWindow) {
        topWindow.focus();
    } else {
        topWindow = wm.getMostRecentWindow(null);
        var win = topWindow.openDialog(uri, "_blank", features || "chrome",
            args);
    }
}

function FoxmarksOpenInNewTab(url) {
    var wm = Cc['@mozilla.org/appshell/window-mediator;1'].
        getService(Ci.nsIWindowMediator);
    var topWindow = wm.getMostRecentWindow('navigator:browser');
    if (topWindow) {
        var content = topWindow.document.getElementById('content');
        content.selectedTab =
            content.addTab(url);
    }
}

function FoxmarksOpenInNewWindow(url) {
    openDialog("chrome://browser/content/browser.xul", "_blank",
        "chrome,all,dialog=no", url);
}

function OpenFoxmarksSettingsDialog(pane) {
    FoxmarksOpenWindowByType("foxmarks:settings",
        "chrome://foxmarks/content/foxmarks-dialog.xul", 
        "chrome,toolbar,centerscreen",
        [pane || "foxmarks-mainpane"]);
}

function MyFoxmarks() {
    FoxmarksOpenInNewTab("http://my.foxmarks.com/")
}

function FoxmarksReportProblem() {
    FoxmarksOpenInNewTab("http://wiki.foxmarks.com/wiki/Firefox3Beta");
}

function FoxmarksOpenWizard(manual, skipAuth) {
    if (skipAuth) {
        FoxmarksOpenWindowByType("foxmarks:setup",
            "chrome://foxmarks/content/foxmarks-setup.xul",
            "chrome,centerscreen,dialog=no", manual);
    } else {
        FoxmarksOpenWindowByType("foxmarks:login", 
            "chrome://foxmarks/content/foxmarks-login.xul",
            "chrome,centerscreen,dialog=no", manual);
    }
}

function FoxmarksOnWizardCancel() {
    var ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
        .getService(Components.interfaces.nsIPromptService);

    var checkResult = {};
    checkResult.value = gSettings.wizardSuppress;
    var sb = Bundle();

    var ret = ps.confirmCheck(window, sb.GetStringFromName("title.cancelsetup"),
            sb.GetStringFromName("msg.cancelsetup"),
            sb.GetStringFromName("msg.nowizard"),
            checkResult);

    gSettings.wizardSuppress = checkResult.value;

    return ret;
}


function Synch() {
    PerformAction("synch");
}

function FoxmarksOpenStatusWindow() {
    PerformAction("showStatus");
}

function PerformAction(action, arg) {
    var retval = { helpurl: null };

    try {
        var win = window.openDialog(
            "chrome://foxmarks/content/foxmarks-progress.xul", "_blank",
            "chrome,dialog,modal,centerscreen", action, retval, arg);
        if (retval.helpurl) {
            FoxmarksOpenInNewWindow(retval.helpurl);   
        }
    } catch (e) {
        alert(e);
    }
    if (retval.status == 401) {
        alert(Bundle().GetStringFromName("msg.invalidcredentials"));
    }
    return retval.status;
}
